package common

type Task struct {
	ID   int    `json:"id"`
	Path string `json:"path"`
}

type TaskStatus struct {
	ReadyTaskCount     int `json:"ready_task_count"`
	PendingTaskCount   int `json:"pending_task_count"`
	CompletedTaskCount int `json:"completed_task_count"`
	FailedTaskCount    int `json:"failed_task_count"`
}

type StatusCode int

const (
	ReadyTaskStatus StatusCode = 0
	PendingStatus   StatusCode = 1
	CompletedStatus StatusCode = 2
	FailedStatus    StatusCode = 3
)
